*! version 3.0.0  11feb1997
program define integ
	version 5.0
	local varlist "req ex min(2) max(2)"
	local if "opt"
	local in "opt"
	#delimit ;
	local options "Generate(string) REPLACE BY(string) 
		       Trapezoid Initial(real 0)" ;
	#delimit cr
	parse "`*'"
	parse "`varlist'", parse(" ")
	local y "`1'"
	local x "`2'"
	
	if "`by'"!="" { confirm variable `by' }
	
	if "`generat'"!="" {
		if "`replace'"!="" { capture drop `generat' }
		
		confirm new variable `generat'
	}  

	tempvar doit ynew integ
	
	mark `doit' `if' `in'
	markout `doit' `y' `x'
	markout `doit' `by', strok
	
	sort `doit' `by' `x'
	
	Mean `ynew' `y' `x' `doit' `by'
	local y "$S_1"

	quietly count if `doit'
	local n = _result(1)
	if `n'==0 { error 2000 }
		
	if "`trapezoid'"=="" { /* use spline fit */
		tempvar y2
		
		spline_x `y2' `y' `x' `doit' `by'
		
		local spline /*
		*/ "-cond(_N>2,(`x'-`x'[_n-1])^2*(`y2'+`y2'[_n-1])/12,0)"
	}
	
	quietly by `doit' `by': gen float `integ' = `initial' /*
	*/	+ sum((`x'-`x'[_n-1])*(`y'+`y'[_n-1]`spline')/2) if `doit'

	global S_1 `n'
	global S_2 = `integ'[_N]
	
	if "`generat'"!="" { rename `integ' `generat' }
	
	if "`by'"=="" {
		local result : di %10.0g $S_2
		di _n in gr "number of points = " in ye "`n'" _n(2) /*
		*/    in gr "integral         = " in ye trim("`result'")
	} 
end

program define Mean
	local ynew "`1'"
	local y    "`2'"
	local x    "`3'"
	local doit "`4'"
	macro shift 4
	
	capture by `doit' `*': assert `x'!=`x'[_n-1] if _n>1 & `doit'
	if _rc==0 { /* `x' values are unique. */
		global S_1 "`y'"
		exit
	}
	
/* Compute mean of `y' at nonunique `x' values. */

	quietly by `doit' `*' `x': gen double `ynew' /* 
	*/	= cond(_n==_N,sum(`y')/_N,.) if `doit'
	markout `doit' `ynew'
	sort `doit' `*' `x'
	global S_1 "`ynew'"
end 
