*! version 3.2.4  26oct1997
program define ir
	version 3.1
	local varlist "req ex min(3) max(3)"
	local if "opt"
	local in "opt"
	local weight "fweight"
	#delimit ;
	local options "BY(string) noCrude noHet EStandard Fast IRD IStandard Level(integer $S_level) Pool Standard(string) TB";
	#delimit cr
	parse "`*'"
	parse "`varlist'", parse(" ")
	local cas `1'
	local ex  `2'
	local tim `3'
	local stdflg=("`standar'"!="")+("`estanda'"!="")+("`istanda'"!="")
	if `stdflg'>1 { 
		di in red "only one method of standardization may be specified"
		error 198 
	}
	tempvar use wgt first decoded
	quietly { 
		mark `use' `if' `in'
		markout `use' `varlist'
		if "`weight'"!="" { 
			gen double `wgt' `exp' if `use'
			local weight "[fweight=`wgt']"
		}
	}
	if "`by'"!="" { 
		parse "`by'", parse(" ")
		if "`2'"!="" { 
			noi di in red "ir will only accept one by variable"
			return 198 
		} 
		confirm var `by'
		capture replace `use'=0 if `by'==. /* fail on string ok */
		quietly { 
			sort `use' `by'
			if "`standar'"!="" {
				noisily confirm var `standar'
				capture assert `standar'>=0 if `use'
				if _rc { 
					noi di in red /*
					*/ "`standar' has negative values"
					exit 498
				}
				capture by `use' `by': assert /*
				*/ `standar'==`standar'[_n-1] if _n>1 & `use'
				if _rc { 
					noi di in red /*
					*/ "`standar' not constant within `by'"
					exit 198
				}
			}
			by `use' `by': gen byte `first'=1 if _n==1 & `use'
			sort `first' `by'

			if "`crude'" == "" {
				local optex = ("`tb'"=="") + ("`level'"=="") 
				
				if "`level'" != "" { 
					local ml  "level(`level')" }
				else 	local ml

				if `optex' == 2 {
					local myopt ""
				}
				else {
					local myopt ",`tb' `ml'   "
				}

				ir `cas' `ex' `tim' `if' `in' `w' `myopt'

				if "`ird'" != "" {
					local CRUDE  $S_1 
					local C0     $S_2
					local C1     $S_3
				}
				else {
					local CRUDE  $S_4
					local C0     $S_5
					local C1     $S_6
				}
				
				local CTYPE  ""
				if "`tb'" != ""    { local CTYPE  "(tb)" }
				else if "`ird'" == "" { local CTYPE  "(exact)" }
			}
		}
	}
	else {
		if `stdflg'!=0 { 
			di in red "missing by() option"
			error 198 
		}
	}
	capture assert `cas'>=0 & `tim'>=0 if `use'
	if _rc { 
		di in red "`cas' or `tim' takes on negative values"
		exit 499
	}

	_crcvarl `ex'
	local col "col($S_1)"

	_crcvarl `cas'
	local row "row($S_1)"

	_crcvarl `tim'
	local row2 "row2($S_1)"

	if "`by'"=="" { 
		quietly { 
			sum `cas' `weight' if `ex' & `use'
			local a=int(_result(1)*_result(3)+.5)
			sum `tim' `weight' if `ex' & `use'
			local n1=int(_result(1)*_result(3)+.5)
			sum `cas' `weight' if `ex'==0 & `use'
			local b=int(_result(1)*_result(3)+.5)
			sum `tim' `weight' if `ex'==0 & `use'
			local n0=int(_result(1)*_result(3)+.5)
		}
		if `a'==. { local a 0 } 
		if `b'==. { local b 0 } 
		if `n1'==. { local n1 0 } 
		if `n0'==. { local n0 0 } 
		iri `a' `b' `n1' `n0', level(`level') `col' `row' `row2' `tb'
		exit
	}

	if `level'<10 > `level'>99 { local level 95 } 
	local lby : value label `by'
	if "`lby'"!="" { 
		quietly decode `by', gen(`decoded')
		local lby "`decoded'"
	}
	else	local lby `by'

	local i 1
	local df 0
	local sumIRR 0
	local sumwgt 0
	local sumV1 0
	local sumV2 0 
	local sumV3 0
	local sumV4 0
	local pwgt 0
	local pnum 0
	local pden 0
	local suma 0
	local sumb 0
	local sumn0 0
	local sumn1 0

	tempvar irr
	tempvar virr

	quietly gen `irr'=.
	quietly gen `virr'=.

	local lbl : var label `by'
	if "`lbl'"=="" { local lbl "`by'" }
	else local lbl = substr("`lbl'",1,16)
	local skip=16-length("`lbl'")

	if "`ird'"=="" { local hdr "IRR" }
	else {
		if `stdflg'==0 { error 198 }
		local hdr "IRD"
	}
	if `stdflg'==0 { local hdr2 "M-H" }
	else local hdr2 "   "

	di _n in gr _skip(`skip') "`lbl' |" _col(25) "`hdr'" /*
	*/ _col(34) "[`level'% Conf. Interval]    `hdr2' Weight" _n /*
	*/ _dup(17) "-" "+" _dup(49) "-"

	local IRR0 . 
	local IRR1 . 
	local P0 .
	local P1 .
	local POOL .
	local nf ""
	while 1 { 
		if `first'[`i']!=1 {		/* end of loop */
			local iz=invnorm(1-(1-`level'/100)/2)
			mac def S_1 .
			mac def S_2 .
			mac def S_3 . 
			mac def S_4 . 
			mac def S_5 . 
			mac def S_6 .
			if `stdflg'==0 {	/* M-H */
				local IRR = `sumIRR'/`sumwgt'
				local var=`sumV1'/(`sumV2'*`sumV3')
				local sd=sqrt(`var')
				local IRR0=exp(ln(`IRR')-`iz'*`sd')
				local IRR1=exp(ln(`IRR')+`iz'*`sd')
				mac def S_4 `IRR'
				mac def S_5 `IRR0'
				mac def S_6 `IRR1'
				local hdr2 "   M-H combined"
				local hdr3 "(M-H)    "
			}
			else {
				if "`estanda'"!="" {
					local hdr2 "E. Standardized"
					local hdr3 "(E.S.)   "
				}
				else if "`istanda'"!="" {
					local hdr2 "I. Standardized"
					local hdr3 "(I.S.)   "
				}
				else {
					local hdr2 "   Standardized"
					local hdr3 "(std.)   "
				}
				if "`ird'"!="" {
					local IRR = `sumIRR'/`sumwgt'
					local sd=sqrt(`sumV1'/`sumwgt'^2)
					local IRR0=`IRR'-`iz'*`sd'
					local IRR1=`IRR'+`iz'*`sd'
					mac def S_1 `IRR'
					mac def S_2 `IRR0'
					mac def S_3 `IRR1'
				}
				else {
					local IRR=`sumV2'/`sumV4'
					local sd=sqrt(`sumV1'/`sumV2'^2 + /*
						*/    `sumV3'/`sumV4'^2)
					local IRR0=exp(ln(`IRR')-`iz'*`sd')
					local IRR1=exp(ln(`IRR')+`iz'*`sd')
					mac def S_4 `IRR'
					mac def S_5 `IRR0'
					mac def S_6 `IRR1'
				}
			}
			if "`ird'"=="" {
				local POOL=exp(`pnum'/`pden')
				local sd=sqrt(1/`pden')
				local P0=exp(ln(`POOL')-`iz'*`sd')
				local P1=exp(ln(`POOL')+`iz'*`sd')
				local dfm1=`df'-1
				tempvar sumf
				quietly gen `sumf'=.
				quietly replace `sumf'= sum( /*
				  */ (ln(`irr')-ln(`POOL'))^2/`virr') /*
				  */ in 1/`df'
				local pchi=`sumf'[`dfm1'+1]
quietly summ `irr' in 1/`df'
local cdf = _result(1) - 1
				*local pval=chiprob(`dfm1',`pchi')
local pval=chiprob(`cdf',`pchi')
				quietly replace `sumf'= sum( /*
				  */ (ln(`irr')-ln(`IRR'))^2/`virr') /*
				  */ in 1/`df'
				local mchi=`sumf'[`dfm1'+1]
quietly summ `irr' in 1/`df'
local cdf = _result(1) - 1
				*local mval=chiprob(`dfm1',`mchi')
local mval=chiprob(`cdf',`mchi')
			}
			else {
				local POOL=`pnum'/(`pden')
				local sd=sqrt(1/`pden')
				local P0=`POOL'-`iz'*`sd'
				local P1=`POOL'+`iz'*`sd'
				local dfm1=`df'-1
				tempvar sumf
				quietly gen `sumf'=.
				quietly replace `sumf'= sum( /*
				  */ (`irr'-`POOL')^2/`virr') /*
				  */ in 1/`df'
				local pchi=`sumf'[`dfm1'+1]
quietly summ `irr' in 1/`df'
local cdf = _result(1) - 1
				*local pval=chiprob(`dfm1',`pchi')
local pval=chiprob(`cdf',`pchi')
				quietly replace `sumf'= sum( /*
				  */ (`irr'-`IRR')^2/`virr') /*
				  */ in 1/`df'
				local mchi=`sumf'[`dfm1'+1]
quietly summ `irr' in 1/`df'
local cdf = _result(1) - 1
				*local mval=chiprob(`dfm1',`mchi')
local mval=chiprob(`cdf',`mchi')
			}

local dfm1 = `cdf'
			di in gr _dup(17) "-" "+" _dup(49) "-" 
			if "`crude'" == "" {
			  di in gr "           Crude |  " in ye   /*
			  */ %9.0g `CRUDE' "    " %9.0g `C0' "  " /*
			  */ %9.0g `C1' in gr _col(70) "`CTYPE'"
			}
 			if "`pool'" != "" {
			  di in gr " Pooled (direct) |  " in ye   /*
			  */ %9.0g `POOL' "    " %9.0g `P0' "  "  /*
			  */ %9.0g `P1'
			}
			di in gr " `hdr2' |  " in ye /* 
			*/ %9.0g `IRR' "    " %9.0g `IRR0' "  " %9.0g `IRR1'

 			if "`het'" == "" {
			  if `stdflg'==0 | "`pool'"!="" {
			    di in gr _dup(17) "-" "+" _dup(49) "-" 
			  }
			  if "`pool'" != "" {
			    if `dfm1' > 0 {
			      di in gr /* 
			      */ " Test for heterogeneity " /*
			      */ "(direct) chi2(" in ye "`dfm1'" in gr  /*
			      */ ") = " in ye %9.2f `pchi'           /*
			      */ in gr "  Pr>chi2 = " in ye %6.4f `pval'
			      global S_26 = `dfm1'
			      global S_27 = `pchi'
			    }
			    else {
			      global S_26
			      global S_27
			    }
			  }
			  if "`hdr3'" == "(M-H)    " {
			    if `dfm1' > 0 {
			      di in gr /* 
			      */ " Test for heterogeneity " /* 
			      */ "`hdr3'" "chi2(" in ye "`dfm1'" in gr  /*
			      */ ") = " in ye %9.2f `mchi'           /* 
			      */ in gr "  Pr>chi2 = " in ye %6.4f `mval'
			      global S_25 = `mchi'
			      global S_26 = `dfm1'
			    }
			  }
			}
			*if "`nf'"=="error" & `stdflg'==0{ 
			  *di
			  *di in bl "Note: Stratum specific estimates appear"/*
			  **/	" both sides of the null value. "
			  *di in bl "      This problem may require " /*
			  * */ " standardization."
			*}
			exit
		}
		quietly { 
			sum `cas' `weight' if `ex' & `use' & `by'==`by'[`i']
			local a=int(_result(1)*_result(3)+.5)
			sum `tim' `weight' if `ex' & `use' & `by'==`by'[`i']
			local n1=int(_result(1)*_result(3)+.5)
			sum `cas' `weight' if `ex'==0 & `use' & `by'==`by'[`i']
			local b=int(_result(1)*_result(3)+.5)
			sum `tim' `weight' if `ex'==0 & `use' & `by'==`by'[`i']
			local n0=int(_result(1)*_result(3)+.5)
		}
		if `a'==. { local a 0 } 
		if `b'==. { local b 0 } 
		if `n1'==. { local n1 0 } 
		if `n0'==. { local n0 0 } 
		if `stdflg'==0 {	/* M-H */
			local wgt=`b'*`n1'/(`n1'+`n0')
			local T=`n1'+`n0'
			local IRR=(`a'/`n1')/(`b'/`n0')

			*local sumIRR=`sumIRR'+`wgt'*`IRR'
local sumIRR=`sumIRR'+`a'*`n0'/(`n1'+`n0')

			local sumwgt=`sumwgt'+`wgt'
			local sumV1=`sumV1'+((`a'+`b')*`n1'*`n0')/(`T'^2)
			local sumV2=`sumV2'+`a'*`n0'/`T'
			local sumV3=`sumV3'+`b'*`n1'/`T'
		}
		else {
			if "`estanda'"!="" { local wgt `n0' }
			else if "`istanda'"!="" { local wgt `n1' }
			else local wgt=`standar'[`i']
			local sumwgt=`sumwgt'+`wgt'
			if "`ird'"!="" {	/* standardize ird */
				local IRR=`a'/`n1' - `b'/`n0'
				local sumIRR=`sumIRR'+`wgt'*`IRR'
				local VRD=`a'/`n1'^2 + `b'/`n0'^2
				local sumV1=`wgt'^2*`VRD'
			}
			else {			/* standardize irr */
				local R1=`a'/`n1'
				local R0=`b'/`n0'
				local IRR=`R1'/`R0'
				local varR1=`a'/`n1'^2
				local varR0=`b'/`n0'^2
				local sumV1=`sumV1'+`wgt'^2*`varR1'
				local sumV2=`sumV2'+`wgt'*`R1'
				local sumV3=`sumV3'+`wgt'^2*`varR0'
				local sumV4=`sumV4'+`wgt'*`R0'
			}
		}
		if "`ird'"=="" {
			local pwgt=(`a'*`b')/(`a'+`b')
			local pnum=`pnum'+`pwgt'*log(`IRR')
			quietly replace `virr'=(1/`a'+1/`b') in `i'
		}
		else {
			local pwgt=1/`VRD'
			local pnum=`pnum'+`pwgt'*`IRR'
			quietly replace `virr'=`VRD' in `i'
		}
		local pden=`pden'+`pwgt'
		local suma=`suma'+`a'
		local sumb=`sumb'+`b'
		local sumn0=`sumn0'+`n0'
		local sumn1=`sumn1'+`n1'	
		quietly replace `irr'=`IRR' in `i'

		local df=`df'+1
		mac def S_4
		if "`fast'"=="" {
			if "`ird'"=="" { 
				_crcirr `a' `b' `n1' `n0' `level' `tb'
/*
				if "`nf'"=="" {
					if $S_1 < 1.0 { local nf "below" }
					else          { local nf "above" }
				}
				else {
					if $S_1 < 1.0 & "`nf'"=="above" { 
						local nf "error" 
					}
					else if $S_1 > 1.0 & "`nf'"=="below" { 
						local nf "error" 
					}
				}
*/
			}
			else {
				_crcird `a' `b' `n1' `n0' `level' `tb'
/*
				if "`nf'"=="" {
					if $S_1 < 0.0 { local nf "below" }
					else          { local nf "above" }
				}
				else {
					if $S_1 < 0.0 & "`nf'"=="above" { 
						local nf "error" 
					}
					else if $S_1 > 0.0 & "`nf'"=="below" { 
						local nf "error" 
					}
				}
*/
			}

			local IRR0 $S_2
			local IRR1 $S_3
		}
		local lbl=`lby'[`i']
		local lbl=substr("`lbl'",1,16)
		local skip=16-length("`lbl'")
		di in gr _skip(`skip') "`lbl' |  " in ye /*
		*/ %9.0g `IRR' "    " %9.0g `IRR0' "  " %9.0g `IRR1' /*
		*/ "     " %9.0g `wgt' in gr "  $S_4"
		local i=`i'+1
	}
	/*NOTREACHED*/
end
exit
         1         2         3         4         5         6
1234567890123456789012345678901234567890123456789012345678901234567890
             age |      IRR      [95% Conf. Interval]    M-H Weight
-----------------+-------------------------------------------------
               1 |  12345678912341234567891212345678912345123456789
               2 |  123456789    123456789  123456789     123456789
-----------------+-------------------------------------------------
1234M-H combined |  123456789    123456789  123456789

(confidence intervals exact within stratum, combined is approximate)
