*! version 2.1.3  12nov1996
program define loneway
	version 4.0
	global S_1	/* intra-indepvar correlation */
	global S_2	/* DEFF	*/
	global S_3	/* ACS */
	local varlist "req ex max(2) min(2)"
	local options "Quiet"
	local in "opt"
	local if "opt"
	local weight "aweight"	/* does not work for fweight - wwg */
	parse "`*'"
	parse "`varlist'", parse(" ")
	tempvar fac nn nn1
	tempname SSW DFT DFA SST SSA DFW F
	tempname D2OVNU VARF SDF NN RATIO SDRATIO RHO SDRHO RELIA
	tempname estsd DEFLAT
	preserve
	quietly {
		if "`if'`in'"~="" {
			keep `if' `in'
		}
		drop if `1'==. | `2'==.
		if "`exp'"~="" {
			tempvar wt
			gen double `wt' `exp'
			drop if `wt' <= 0 | `wt'==.
			summ `wt'
			replace `wt' = `wt' / _result(3)
			keep `1' `2' `wt'
		}
		else {
			keep `1' `2'
			local wt 1
		}
		sort `2'
		by `2': gen double `fac' = sum(`1'*`wt')/sum(`wt')
		by `2': replace `fac' = (`1' - `fac'[_N])^2
		replace `fac' = sum(`fac'*`wt')
		scalar `SSW' = `fac'[_N]
		count if `2' != `2'[_n-1]
		scalar `DFA' = _result(1) - 1
		summ `1' [aw=`wt']
		scalar `DFT' = _result(1) - 1
		scalar `SST' = _result(4) * `DFT'
		scalar `SSA' = `SST' - `SSW'
		scalar `DFW' = `DFT' - `DFA'
		scalar `F'   = `SSA' / `DFA' * `DFW' / `SSW'
		if "`quiet'"=="" {
			local lab : variable label `1'
			local lbl /*
			*/ "One Way Analysis of Variance for `1': `lab'"
			local indent = int((80-length("`lbl'"))/2)
			noisily di _n _skip(`indent') in gr "`lbl'"
			noisily di _n in gr /*
				*/ _col(5) "Source" _col(25) "SS" /*
				*/ _col(36) "df" _col(44) "MS" /*
				*/ _col(58) "F" _col(64) "Prob > F" /*
				*/ _n _dup(72) "-"
			noisily di in gr "Between `2'" in yellow /*
				*/ _col(21) %10.0g `SSA' /*
				*/ _col(32) %6.0f `DFA'  /*
				*/ _col(41) %10.0g `SSA'/`DFA' /*
				*/ _col(52) %9.2f `F' /*
				*/ _col(66) %6.4f fprob(`DFA',`DFW',`F')
			noisily di in gr "Within `2'" in yellow /*
				*/ _col(21) %10.0g `SSW' /*
				*/ _col(32) %6.0f `DFW' /*
				*/ _col(41) %10.0g `SSW'/`DFW' /*
				*/ _n in gr _dup(72) "-"
			noisily di in gr "Total" in yellow /*
				*/ _col(21) %10.0g `SST' /*
				*/ _col(32) %6.0f `DFT' /*
				*/ _col(41) %10.0g `SST'/`DFT'

			noisily di _n in gr _col(42) "R-squared =" /*
				*/ in yellow %7.4f `SSA'/`SST'
			if (`F' < 1) {
				noisily di in gr "No evident reliability: F < 1"
				exit 0
			}
		}
		* D2 is the noncentrality for the numerator; Scheffe p. 413
		/* mac def estsdw = sqrt(`SSW'/`DFW') */
		scalar `D2OVNU' = max(`F'-1,0)
		scalar `VARF' = (2+4*`D2OVNU')/`DFA' + `F'^2*2/`DFW'
		scalar `SDF' = sqrt(`VARF')
		by `2': gen double `nn' = _N
		by `2': drop if _n!=_N
		gen double `nn1' = (`nn'*(`nn' -1))
		replace `nn' = sum(1/`nn')
		replace `nn1' = sum(`nn1')
		scalar `NN' = `nn'[_N]
		scalar `RATIO' = (`F' - 1) * (`DFA'+1) / (`DFT'+1)
		scalar `SDRATIO' = (`DFA'/`DFT') * `SDF'
		scalar `RHO' = `RATIO'/(1+`RATIO')
		global S_1 = `RHO'
		scalar `SDRHO' = `SDRATIO' / (1+`RATIO')^2
		scalar `RELIA' = 1 / (1 + (1-`RHO')/`RHO'*(`NN'/(`DFA'+1)))
		scalar `estsd' = sqrt(`SST'/`DFT' - `SSW'/`DFW')
		scalar `DEFLAT' = sqrt((`nn1'[_N]*`RHO')/(`DFT'+1) + 1)
		global S_2 = (`nn1'[_N]*`RHO')/(`DFT'+1) + 1
		global S_3 = `nn1'[_N]/(`DFT'+1) + 1
		if ("`quiet'"=="") {
			local lbl "Estimated SD of `2' effect ="
			local indent = 52 - length("`lbl'")
			noisily di _skip(`indent') in gr "`lbl' " /*
				*/ in ye `estsd'

			local lbl "Estimated SD within `2' ="
			local indent = 52 - length("`lbl'")
			noisily di _skip(`indent') in gr "`lbl'" /*
				*/ , in ye sqrt(`SSW'/`DFW')

			local lbl "Intra-`2' correlation ="
			local indent = 52 - length("`lbl'")
			noisily di _skip(`indent') in gr "`lbl'" /*
				*/ in yel %7.4f `RHO' /*
				*/ in gr " (SD =" /*
				*/ in ye %7.4f `SDRHO' in gr ")"

			local lbl /*
			*/ "Estimated reliability of a `2'-averaged score ="
			local indent = 52 - length("`lbl'")
			noisily di _n _skip(`indent') in gr "`lbl'" /*
				*/ in ye %7.4f `RELIA'
			noisily di _col(28) in gr "Conservative t-deflator =" /*
				*/ in ye %7.4f `DEFLAT'

		}
	}
end
