*! version 3.2.1  12nov1996
program define mvreg
	version 3.1
	local myopt "Level(integer $S_level) noTable noHeader CORr"
	tempname sigma tsig
	tempname rcv
	if ("`1'"!="" & substr("`1'",1,1)!=",") {
		parse "`*'", parse(" :,")
		local i 1
		while ("`1'"!=":" & "`1'"!="," & "`1'"!="") {
			local eqlist "`eqlist' `1'"
			mac shift
		}
		if ("`1'"==":") { mac shift }
		local roc "`*'"
		local varlist "req ex"
		parse "`eqlist'"
		local eqnames "`varlist'"

		local varlist "req ex"          /* does not handle null list */
		local options "`myopt' noCONs"
		local if "opt"
		local in "opt"
		local weight "aweight fweight"
		parse "`*'"

		local neq : word count `eqnames'
		local i 1
		while (`i'<=`neq') {
			local eqn : word `i' of `eqnames'
			eq `eqn' `varlist'
			local i = `i' + 1
		}
		tempvar touse
		mark `touse' `if' `in' [`weight'`exp']
		markout `touse' `eqnames' `varlist'

		tempname ee xx xy yy bb xxi pv cxxi b idfe
		qui mat accum `ee' = `eqnames' `varlist' if `touse' [`weight'`exp'], `cons'
		local nobs = _result(1)
		local neqp1 = `neq' + 1
		mat `xx' = `ee'[`neqp1'...,`neqp1'...]
		mat `xy' = `ee'[`neqp1'...,1..`neq']
		mat `yy' = `ee'[1..`neq',1..`neq']
		mat drop `ee'
		mat `xxi' = syminv(`xx')
		mat `bb' = `xy'' * `xxi'
		mat `pv' = `bb' * `xx'
		mat `pv' = `pv' * `bb''
		mat `rcv' = `yy' - `pv'
		local dfe = `nobs' - rowsof(`xx')
		scalar `idfe' = 1/`dfe'
		mat `rcv' = `rcv' * `idfe'
		mat `cxxi' = `rcv' # `xxi'
		local i 1
		while (`i' <= `neq') {
			mat `xx' = `bb'[`i',.]
			local eqn : word `i' of `eqnames'
			mat coleq `xx' = `eqn'
			mat `b' = `b' , `xx'
			local t : display %9.0g sqrt(`rcv'[`i',`i'])
			local sd "`sd' `t'"
			qui summ `eqn' if `touse' [`weight'`exp']
			if ("`cons'"=="") {
				local t = 1 - `rcv'[`i',`i']*`dfe' /*
					     */ /(_result(1)-1)/_result(4)
			}
			else local t = 1 - `rcv'[`i',`i']*`dfe'/`yy'[`i',`i']
			local t : display %6.4f `t'
			local r2 "`r2' `t'"
			local i = `i' + 1
		}
		mat post `b' `cxxi', dof(`dfe')
		local i 1
		while (`i' <= `neq') {
			local eqn : word `i' of `eqnames'
			qui test [`eqn']
			local t : display %9.0g _result(6)
			local f "`f' `t'"
			local t : display %6.4f /*
				*/ fprob(_result(3),_result(5),_result(6))
			local prv "`prv' `t'"
			local i = `i' + 1
		}
		global S_E_r2 "`r2'"
		global S_E_pv "`prv'"
		global S_E_sd "`sd'"
		global S_E_f "`f'"
		global S_E_elis "`eqnames'"
		global S_E_par = colsof(`bb')
		global S_E_tdf = `dfe'
		global S_E_neq `neq'
		global S_E_nobs `nobs'
		matrix S_E_rcv = `rcv'
		global S_E_cmd "mvreg"
		mat drop `xx' `yy' `xy' `bb' `rcv'
	}
	else {
		if ("$S_E_cmd"!="mvreg") { error 301 }
		local options "`myopt'"
		parse "`*'"
	}
	if ("`header'"=="") {
		local i 1
		di
		di in gr "Equation      Obs  Parms        RMSE    " _quote "R-sq" _quote "          F        P"
		di in gr "------------------------------------------------------------------"
		while (`i'<=$S_E_neq) {
			local myword : word `i' of $S_E_elis
			local sd : word `i' of $S_E_sd
			local r2 : word `i' of $S_E_r2
			local f  : word `i' of $S_E_f
			local pv : word `i' of $S_E_pv
			local parms $S_E_par
			local nobs $S_E_nobs
			di in ye "`myword'" _col(10) %8.0f `nobs' /*
				*/ %7.0f `parms' /*
				*/ "   " %9.0g `sd' %10.4f `r2' "  " /*
				*/ %9.0g `f' %9.4f `pv'
			local i = `i' + 1
		}
	}
	if ("`table'"=="") {
		di
		mat mlout , level(`level')
	}
	if ("`corr'"!="") {
		di
		mat `sigma' = corr(S_E_rcv)
		di in gr "Correlation matrix of residuals:"
		mat list `sigma', nohead format(%9.4f)
		mat `sigma' = `sigma' * `sigma' '
		local tsig = (trace(`sigma') - $S_E_neq)*$S_E_nobs/2
		local df = $S_E_neq*($S_E_neq-1)/2
		di
		di in gr "Breusch-Pagan test of independence: chi2(`df') = " /*
		*/ in ye %9.3f `tsig' in gr ", Pr = " %6.4f /* 
		*/ in ye chiprob(`df',`tsig')
		global S_3 `df'
		global S_4 `tsig'
	}
end
exit
