*! version 1.0.2  8oct1997
program define pctile
        version 5.0
        
        _parsewt "aweight fweight pweight" `*' /* parse weights if any */
        local wt "$S_2" /* contains [weight=exp] or nothing */
  
        local varlist "req new max(1)"
        local exp "req noprefix"
        local if "opt"
        local in "opt"
        local options "Nquantiles(integer 2) ALTdef Genp(string)"

        tempvar touse q

        nobreak {
	        	parse "$S_1"
	        	rename `varlist' `q'
        }

	if "`wt'"!="" & "`altdef'"!="" {
		di in red "altdef option cannot be used with weights"
		exit 198
	}
        if `nquanti' < 2 {
                di in red "nquantiles() must be greater than or equal to 2"
                exit 198
        }
        if `nquanti' > _N + 1 {
                di in red "nquantiles() must be less than or equal to " /*
                */ "number of observations plus one"
                exit 198
        }
	if "`genp'"!="" {
		confirm new variable `genp'
		local nvar : word count `genp'
		if `nvar' > 1 {
			di in red "only one variable allowed in genp()"
			exit 198
		}
	}

/* Set up variable to give quantiles. */
        
        capture confirm variable `exp'
        if _rc {
		tempvar x
		qui gen double `x' = `exp'
        }
        else	local x "`exp'"

/* Mark/markout. */
        
        mark `touse' `wt' `if' `in'
        markout `touse' `x'

	qui count if `touse'
	if _result(1) == 0 { error 2000 }
        
/* Get quantiles. */

	local last = `nquanti' - 1

	if `nquanti' <= 21 {
		_pctile `x' `wt' if `touse', n(`nquanti') `altdef'
		qui replace `q' = _result(_n) in 1/`last'
	}
	else {
	        sort `x'
		local iold 1
		local j 1
		local i 1
		while `i' <= `last' {
			local pct = 100*`i'/`nquanti' 
			if "`plist'"=="" { local plist "`pct'" }
			else		   local plist "`plist',`pct'"

			if `j' == 20 | `i' == `last' {
				_pctile `x' `wt' if `touse', p(`plist') `altdef'
				qui replace `q' = _result(_n-`iold'+1) /*
				*/	in `iold'/`i'
				local plist
				local iold = `i' + 1
				local j 1
			}
			local j = `j' + 1
			local i = `i' + 1
		}
	}

        label var `q' "percentiles of `exp'"
        rename `q' `varlist'
	if "`genp'"!="" {
		qui gen float `genp' = 100*_n/`nquanti' in 1/`last'
		label var `genp' "percentages for `q'"
	}
end
 
