*! version 1.2.0  14oct1997
program define svy_preg
	version 5.0
	local name "`1'"

	if "`name'"=="save" {
		local Vdeff "`2'"
		local Vmeff "`3'"

	/* Save results from _robust(). */

		global S_E_nobs = _result(1) /* number of obs		     */
		global S_E_nstr = _result(2) /* number of strata	     */
		global S_E_npsu = _result(3) /* number of PSUs		     */
		global S_E_npop = _result(4) /* pop. size   	             */

		if _result(5)!=. {
			global S_E_osub = _result(5) /* # subpop. obs	     */
			global S_E_nsub = _result(6) /* subpop. size	     */
		}
		global S_E_wgt  "$S_VYwgt"   /* weight type		     */
		global S_E_exp  "$S_VYexp"   /* weight expression	     */
		global S_E_str  "$S_VYstr"   /* strata variable		     */
		global S_E_psu  "$S_VYpsu"   /* psu variable		     */
		global S_E_fpc  "$S_VYfpc"   /* fpc variable		     */
		global S_E_depv "$S_VYdepv"  /* dependent variable	     */
		global S_E_fail "$S_VYfail"  /* # comp. determined failures  */
		global S_E_succ "$S_VYsucc"  /* # comp. determined successes */
		global S_E_adj  "$S_VYadj"   /* "noadjust" if specified      */
		global S_E_ncat "$S_VYncat"  /* # categories (ologit, oprobit,
                                                and mlogit)                  */
		global S_E_base "$S_VYbase"  /* base category (mlogit only)  */

	/* Compute model F test: create S_E_f and S_E_mdf. */

		Ftest

	/* Make matrices S_E_deff, S_E_deft, S_E_meft, S_E_Vsrs, S_E_Vmsp,
	   and if fpc, S_E_Vswr.
	*/
		MakeDeff `Vdeff'
		if "`Vmeff'"!="" { MakeMeff `Vmeff' }

	/* Erase S_VY macros. */

		macro drop S_VY*
		exit
	}

/* Other S_VY macros:

	S_VYindv  independent variables
	S_VYsub	  subpop. expression = "`doit'" or "`doit' & `subpop'!=0"
	S_VYdopt  user's display options
	S_VYopt   options for _robust
	S_VYsrss  "srssubpop" if specified

	S_VYmopt  maximize options
	S_VYcons  "nocons" if specified

	S_VYeopt  estimation options

	Note: S_VYmopt and S_VYcons can be dropped next	release.
*/

/* Here only if caller wants to parse, etc. */

	local doit "`2'" /* mark variable */
	macro shift 2

/* Parse. */

	if "`name'"=="reg" {
		local iweight "iweight"
		local mopt "noCONstant"  /* set in svyreg next release */
	}
	else if "`name'"=="logit" {
		local mopt "noCONstant LOg *"
					/* set in svy_logt next release */
		local or "OR"
	}
	else if "`name'"=="probit" {
		local mopt "noCONstant LOg *"
	}
	else if "`name'"=="mlogit" {
		local rrr "RRr"
	}

	local varlist "req ex"
	local weight "pweight `iweight' noprefix"
	local if "opt"
	local in "opt"
	#delimit ;
	local options "STRata(string) PSU(string) FPC(string) SUBpop(string)
		       SRSsubpop noADJust `mopt' `or' `rrr'
		       Level(int $S_level) Prob CI DEFF DEFT MEFF MEFT *" ;
	#delimit cr
	parse "`*'"

	if "`srssubp'"!="" & "`subpop'"=="" {
		di in red "srssubpop can only be specified when subpop() " /*
		*/	"is specified"
		exit 198
	}
	if "`subpop'"!="" {
		capture confirm variable `subpop'
		if _rc {
			di in red "subpop() must specify a variable name"
			exit 198
		}
		unabbrev `subpop'
		local subpop "$S_1"
		if $S_2 > 1 {
			di in red "only one variable allowed in subpop() " /*
			*/ "option"
			exit 198
		}
	}

/* Set global macros. */

	global S_VYdopt  /*
	*/ "level(`level') `prob' `ci' `deff' `deft' `meff' `meft' `or' `rrr'"

	if "`name'"=="reg" | "`name'"=="logit" | "`name'"=="probit" {
		if "`log'"=="" { local log "nolog" }
		global S_VYmopt "`log' `options'"
		global S_VYcons "`constan'"
	}
	else global S_VYeopt "`options'"

	global S_VYsrss "`srssubp'"
	global S_VYopt  "`srssubp'"
	global S_VYadj  "`adjust'"

	parse "`varlist'", parse(" ")
	global S_VYdepv "`1'"
	macro shift
	global S_VYindv "`*'"

/* Get weights. */

	if "`exp'"=="" {
		svy_get pweight, optional
		local exp "$S_1"
	}
	else if "`weight'"=="pweight" { /* try to varset pweight variable */
		capture confirm variable `exp'
		if _rc==0 {
			svy_get pweight `exp'
			local exp "$S_1"
		}
	}
	if "`exp'"!="" {
		global S_VYexp "`exp'"
		if "`weight'"!="" { global S_VYwgt "`weight'" }
		else		    global S_VYwgt  pweight

		capture confirm variable `exp'
		if _rc {
			tempvar w
			qui gen double `w' = `exp'
		}
		else	local w "`exp'"
	}

/* Get strata, psu, and fpc. */

	svy_get strata `strata', optional
	global S_VYstr "$S_1"
	if "$S_VYstr"!="" { global S_VYopt "$S_VYopt strata($S_VYstr)" }

	svy_get psu `psu', optional
	global S_VYpsu "$S_1"
	if "$S_VYpsu"!="" { global S_VYopt "$S_VYopt psu($S_VYpsu)" }

	svy_get fpc `fpc', optional
	global S_VYfpc "$S_1"
	if "$S_VYfpc"!="" { global S_VYopt "$S_VYopt fpc($S_VYfpc)" }

/* Mark. */

	mark `doit' `if' `in'

/* Check for negative weights if pweights. */

	if "$S_VYwgt"=="pweight" {
		capture assert `w' >= 0 if `doit'
		if _rc { error 402 }
	}

/* Markout. */

	markout `doit' $S_VYdepv $S_VYindv `w' $S_VYfpc `subpop'
	markout `doit' $S_VYstr $S_VYpsu, strok

/* Compute total #obs. */

	qui count if `doit'
	local nobs = _result(1)
	if `nobs' == 0 { error 2000 }

/* Handle subpop.  If no subpop, S_VYsub is mark variable `doit'. */

	if "`subpop'"=="" {
		global S_VYsub "`doit'"
	}
	else {
		global S_VYopt "$S_VYopt subpop(`subpop')"
		global S_VYsub "(`doit'&`subpop'!=0)"

		ChkSub `nobs' `doit' `subpop'
	}

/* Remove collinearity for all commands except reg, logit, and probit. */

	if "`name'"!="reg" & "`name'"!="logit" & "`name'"!="probit" {
		if "$S_VYwgt"!="" {
			_rmcoll $S_VYindv [$S_VYwgt=$S_VYexp] if $S_VYsub, /*
			*/	$S_VYcons
		}
		else    _rmcoll $S_VYindv if $S_VYsub, $S_VYcons

			/* Note: _rmcoll always prints out blank line */

		global S_VYindv "$S_1"
	}
end

program define ChkSub
	local nobs   "`1'"
	local doit   "`2'"
	local subpop "`3'"

	qui count if `subpop'!=0 & `doit'
	local osub = _result(1)
	if `osub' == 0 {
		di in red "no observations in subpop() subpopulation"    _n /*
		*/ "subpop() = 1 indicates observation in subpopulation" _n /*
		*/ "subpop() = 0 indicates observation not in subpopulation"
		exit 2000
	}
	if `osub' == `nobs' {
		di in blu _n "Note: subpop() subpopulation is same as full " /*
		*/ "population" _n /*
		*/ "subpop() = 1 indicates observation in subpopulation" _n /*
		*/ "subpop() = 0 indicates observation not in subpopulation"
		exit
	}
	qui count if `subpop'!=1 & `subpop'!=0 & `doit'
	if _result(1) > 0 {
		di in blu _n "Note: subpop() takes on values other than " /*
		*/ "0 and 1" _n "subpop() ~= 0 indicates subpopulation"
	}
end

program define MakeDeff
	local Vdeff "`1'"

/* Save S_E_Vsrs. */

	matrix S_E_Vsrs = `Vdeff'
	matrix drop `Vdeff'

/* Get design-based covariance matrix. */

	tempname V f
	matrix `V' = get(VCE)
	matrix `V' = vecdiag(`V')

	if "$S_E_fpc"!="" { /* create S_E_Vswr matrix */
		if "$S_VYsrss"=="" {
			scalar `f' = 1/(1-$S_E_nobs/$S_E_npop)
		}
		else	scalar `f' = 1/(1-$S_E_osub/$S_E_nsub)

		if `f'==. { scalar `f' = 0 }

		matrix S_E_Vswr = `f'*S_E_Vsrs /* unwind fpc on Vsrs */

		local Vdeft "S_E_Vswr"
	}
	else	local Vdeft "S_E_Vsrs"

	matrix S_E_deff = `V'
	matrix S_E_deft = `V'

	local dim = colsof(`V')
	local i 1
	while `i' <= `dim' {
		scalar `f' = `V'[1,`i']/S_E_Vsrs[`i',`i']
		matrix S_E_deff[1,`i'] = cond(`f'!=., `f', 0)

		scalar `f' = sqrt(`V'[1,`i']/`Vdeft'[`i',`i'])
		matrix S_E_deft[1,`i'] = cond(`f'!=., `f', 0)

		local i = `i' + 1
	}
end

program define MakeMeff
	local Vmeff "`1'"

/* Save S_E_Vmsp. */

	matrix S_E_Vmsp = `Vmeff'
	matrix drop `Vmeff'

/* Get design-based covariance matrix. */

	tempname V f
	matrix `V' = get(VCE)
	matrix `V' = vecdiag(`V')

	matrix S_E_meft = `V'

	local dim = colsof(`V')
	local i 1
	while `i' <= `dim' {
		scalar `f' = sqrt(`V'[1,`i']/S_E_Vmsp[`i',`i'])
		matrix S_E_meft[1,`i'] = cond(`f'!=., `f', 0)

		local i = `i' + 1
	}
end

program define Ftest
	global S_E_f   "."
	global S_E_mdf "."

	if "$S_VYindv"=="" {
		global S_E_mdf 0
		exit
	}

	capture test $S_VYindv, min
	if _rc==0 {
		global S_E_mdf = _result(3)
		if "$S_E_adj"=="" { /* adjusted (default) */
			local df = $S_E_npsu - $S_E_nstr
			if `df'-$S_E_mdf+1 > 0 {
				global S_E_f = _result(6) /*
				*/	*(`df'-$S_E_mdf+1)/`df'
			}
		}
		else { /* unadjusted */
			global S_E_f = _result(6)
		}
	}
end
