*! version 5.0.5  17feb1997
program define sw
	version 5.0

	parse "`*'", parse(" ,")

	if "`1'" == "" | "`1'"=="," {
		if "$S_E_cmd"=="" { error 301 }
		di in blue "->$S_E_cmd"
		$S_E_cmd `*'
		exit
	}

	RmGlobal
	global HSW_n 0
	capture noisily DoEst `*' 
	local rc = _rc

	RmGlobal
	exit `rc'
end


program define RmGlobal
	capture confirm integer number $HSW_n
	if _rc==0 {
		if $HSW_n < 2050 {
			local i 1
			while `i' <= $HSW_n {
				global HSW_`i'		/* term */
				local i=`i'+1
			}
		}
	}
	global HSW_n		/* total number of terms	*/

				/* <cmd>-specific macros	*/
	global HSW_cmd		/* estimation command		*/
	global HSW_pcmd		/* post-estimation command or ""*/
	global HSW_op0		/* estimation-time options	*/
	global HSW_op1		/* reply options		*/
	global HSW_typ		/* "reg" or "ml", for testing	*/
	global HSW_res		/* if "ml": pgmname to unload*/
	global HSW_cons		/* "chkcons" or ""		*/

	global HSW_w		/* "[<weight>]" or ""		*/
	global HSW_tu		/* touse tempvar 		*/
	global HSW_cmdX		/* $HSW_cmd varlist $HSW_cmdX	*/

	global HSW_Pr
	global HSW_Pe
	global HSW_hier		/* 0,1: hierarchical model	*/


				/* current model macros		*/
	global HSW_dv		/* dependent variable		*/
	global HSW_cur		/* current indep. vars.		*/
	global HSW_k		/* current # of terms		*/
	global HSW_base


				/* temporary macros		*/
	global HSW_ll0
	global HSW_ll1
	global HSW_d0
	global HSW_d1
	global HSW_AddT		/* 0,1: AddT added a term	*/
	global HSW_RmT		/* 0,1: RmT removed term	*/

				/* to be deleted 		*/
	global HSW_opt
	global HSW_ropt

	capture estimates drop HSW_last
end


program define DoEst /* cmd varlist [if|in|,|[weight]] */
	SetCmd `1'
	unabbrev "`2'"
	global HSW_dv "$S_1"
	mac shift 2

	/* HSW_cur already empty, will contain full term list */
	global HSW_n 0
	IfEndTrm "`1'"
	while $S_1==0 {
		if substr("`1'",1,1)=="(" {
			local list
			while substr("`1'",-1,1)!=")" {
				if "`1'"=="" { 
					di in red "varlist invalid"
					exit 198
				}
				local list "`list' `1'"
				mac shift
			}
			local list "`list' `1'"
			unabbrev `list'
			global HSW_n = $HSW_n + 1
			global HSW_$HSW_n "$S_1"
			global HSW_cur "$HSW_cur $S_1"
		}
		else {
			unabbrev `1'
			local i 1
			local w : word 1 of $S_1
			while "`w'" != "" {
				global HSW_n = $HSW_n + 1
				global HSW_$HSW_n "`w'"
				local i = `i' + 1
				local w : word `i' of $S_1
			}
			global HSW_cur "$HSW_cur $S_1"
		}
		mac shift
		IfEndTrm "`1'"
	}
	local list		/* done with list, save memory 	*/
	local i			/* done with i			*/
	local w			/* done with w			*/

	local varlist
	local if "opt"
	local in "opt"
	local weight "fweight pweight aweight iweight"
	local options "FORWard HIER LR PE(real -1) PR(real -1) LOCkterm1 *"
	parse "`*'"
	CmdOpts `options'

	if `pe'== -1 & `pr'== -1 {
		di in red "must specify pr(#) and/or pe(#) option"
		exit 198
	}
	if `pe'!= -1 & (`pe'<=0 | `pe'>=1) {
		di in red "pe(#) invalid"
		exit 198
	}
	if `pr'!= -1 & (`pr'<=0 | `pr'>=1) {
		di in red "pr(#) invalid"
		exit 198
	}
	if `pe'!= -1 & `pr'!= -1 {
		if "`hier'"!="" {
			di in red "hier pe(#) pr(#) invalid"
			exit 198
		}
		if `pe' >= `pr' { 
			di in red "pr(`pr') <= pe(`pe') invalid"
			exit 198
		}
	}
	if "`forward'" != "" & `pe'== -1 {
		di in red "option forward invalid  or  option pe(#) missing"
		exit 198
	}

	if "`weight'" != "" {
		global HSW_w "[`weight'`exp']"
	}

	if "$HSW_typ"=="ml" & "`lr'"=="" {
		global HSW_typ "reg"
	}
	else if "$HSW_typ"=="reg" & "`lr'"!="" {
		di in red "lr not allowed with $HSW_cmd estimator"
		exit 198
	}

	tempvar touse
	mark `touse' `if' `in' $HSW_w
	markout `touse' $HSW_dv $HSW_cur
	global HSW_tu "`touse'"

	global HSW_cmdX "$HSW_w if `touse', $HSW_op0"

	SetVandS		/* set variables and sample		*/
				/* full model now estimated & set 	*/
	$HSW_cons		/* optionally check _se[_cons] 		*/

	global HSW_Pr `pr'
	global HSW_Pe `pe'
	global HSW_hier = ("`hier'" != "")
	global HSW_AddT 0
	global HSW_RmT 0
	if "`lockter'"!="" {
		global HSW_base "$HSW_1"
		DelTerm 1
		MakeList $HSW_n
	}

	if $HSW_Pr > 0 {
		if $HSW_Pe < 0 {
			DoBSel
		}
		else if "`forward'" != "" {
			DoFSW
		}
		else	DoBSW
	}
	else	DoFSel

	preserve, changed
	capture drop _sample
	rename `touse' _sample
	restore
	label var _sample "sw $HSW_cmd"

	if "$HSW_Pcmd"=="" {
		$HSW_cmd, $HSW_op1
	}
	else {
		$HSW_Pcmd $HSW_dv $HSW_base $HSW_cur $HSW_w if _sample, $HSW_op0 $HSW_op1
		label var _sample "sw $HSW_Pcmd"
	}
end

program define IfEndTrm
	global S_1 1
	if "`1'"=="," | "`1'"=="in" | "`1'"=="if" | "`1'"=="" { exit }
	if substr("`1'",1,1)=="[" { exit }
	global S_1 0
end


program define DoBSel
	FullMdl
	RmT$HSW_typ 1
	while $HSW_RmT {
		RmT$HSW_typ 0
	}
end

program define DoFSel
	NullMdl
	AddT 1
	while $HSW_AddT {
		AddT 0
	}
end

program define DoBSW
	FullMdl
	RmT$HSW_typ 1
	if !$HSW_RmT { exit }
	RmT$HSW_typ 0
	while $HSW_RmT | $HSW_AddT {
		AddT 0
		RmT$HSW_typ 0
	}
end

program define DoFSW
	NullMdl
	AddT 1
	if !$HSW_AddT { exit }
	AddT 0
	while $HSW_AddT | $HSW_RmT {
		RmT$HSW_typ 0
		AddT 0
	}
end

program define FullMdl
	if "$HSW_typ"=="ml" {
		local tt "    LR test"
	}
	di in gr "`tt'" _col(23) "begin with full model"
end

program define NullMdl
	if "$HSW_typ"=="ml" {
		local tt "    LR test"
	}
	if "$HSW_base" == "" {
		local typ "empty"
	}
	else	local typ "term 1"
	di in gr "`tt'" _col(23) "begin with `typ' model"
	global HSW_k 0
	global HSW_cur
	quietly $HSW_cmd $HSW_dv $HSW_base $HSW_cmdX
end



/*
	SetVandS			(set variables and sample)

	remove collinearity from terms.
	verify can estimate full model.
	further restrict sample if estimator does and iterate.
	Return with full model estimated and set.
*/
	

program define SetVandS /* */
	quietly count if $HSW_tu
	local n00 = _result(1) 
	local n0 `n00'
	/* MakeList $HSW_n */	/* not nesc., already set by DoEst 	*/
	while 1 {
		local n : word count $HSW_cur

		qui summ $HSW_tu /* $HSW_w */ if $HSW_tu	/* obtain obs count */
		if _result(1)+2 < `n' { 
			error cond(_result(1)==0,2000,2001)
		}
		FixColl			/* may update HSW_cur */
		CheckEst		/* may update touse */
		if $S_1==0 {		/* did not update touse this time */
			quietly count if $HSW_tu
			if _result(1) != `n00' {
				di in blu "(" `n00'-_result(1) /* 
				*/ " obs. dropped due to estimability)"
			}
			exit 
		}
		local n0 = _result(1)
	}
end


/*
	FixColl

	remove collinearity from terms
	sets HSW_cur and HSW_k to full model
*/

program define FixColl 
	tempname cov

	global HSW_cur		/* rebuild full list	*/
	local i 1
	while `i' <= $HSW_n {
		parse "${HSW_`i'}", parse(" ")
		local n : word count `*'
		if `n' == 1 {
			qui summ `1' /* $HSW_w */ if $HSW_tu
			if _result(5)==_result(6) {
				di in blu "(`1' dropped because constant)"
				DelTerm `i'
				local i = `i' - 1
				local 1
			}
		}
		else {
			qui mat accum `cov' = `*' $HSW_w if $HSW_tu
			qui mat `cov' = syminv(`cov')

			local j 1 
			while `j' < colsof(`cov') {
				if `cov'[`j',`j']==0 {
					di in blu /* 
					*/ "(``j'' dropped due to collinearity)"
					local `j' " "
				}
				local j=`j'+1
			}
			local n : word count `*'
			if `n'==0 {
				DelTerm `i'
				local i=`i'-1
			}
			else	{
				parse "`*'", parse(" ")
				global HSW_`i' "`*'"
			}
		}
		global HSW_cur "$HSW_cur `*'"
		local i=`i'+1
	}
	global HSW_k $HSW_n
	parse "$HSW_cur", parse(" ")
	qui mat accum `cov' = `*' $HSW_w if $HSW_tu
	qui mat `cov' = syminv(`cov')
	local j 1
	while `j' < colsof(`cov') {
		if `cov'[`j',`j']==0 {
			di in red "between-term collinearity, variable ``j''"
			exit 498
		}
		local j=`j'+1
	}
end

/*
	CheckEst

	Given HSW_cur, estimate current model.
	Remove variables dropped by estimator.
	Remove from estimation sample observations dropped by estimator

	Returns:
	S_1 == 0	sample did not change
			HSW_cur correctly set and model estimated

	S_1 == 1	sample did change
			HSW_cur not nesc. set, model not nesc. estimated.
			(meaning CheckEst must be called again, but 
			 only after collinearity is reconsidered.)
*/


program define CheckEst /* */
	capture $HSW_cmd $HSW_dv $HSW_base $HSW_cur $HSW_cmdX
	if _rc {
		di in red "could not estimate full model"
		error _rc
	}

	parse "$HSW_cur", parse(" ")
	local deletes 0
	local i 1
	while "``i''" != "" {
		local x .
		capture local x = _se[``i'']
		local rc = _rc
		if `x'==. | `x'==0 {
			DelVar ``i''
			local deletes 1
		}
		local i = `i'+1
	}
	tempvar hat
	quietly predict `hat' if $HSW_tu
	capture assert `hat'!=. if $HSW_tu
	if _rc {
		markout $HSW_tu `hat'
		global S_1 1
		exit			/* we will be called again */
	}
	if `deletes' {
		MakeList $HSW_n
		quietly $HSW_cmd $HSW_dv $HSW_base $HSW_cur $HSW_cmdX
	}
	global S_1 0
end


program define BI
	quietly $HSW_cmd
	global `1' = _result(2)
	global `2' = _result(3)
end

program define ADO
	global `1' $S_E_ll
	global `2' $S_E_mdf
end


program define tswap /* j k */
	local hold "${HSW_`1'}"
	global HSW_`1' "${HSW_`2'}"
	global HSW_`2' "`hold'"
end


/*
	MakeList #

	set HSW_cur, HSW_k to reflect first # terms
*/

program define MakeList /* k */
	global HSW_k `1'
	global HSW_cur
	local i 1
	while `i' <= $HSW_k { 
		global HSW_cur "$HSW_cur ${HSW_`i'}"
		local i = `i' + 1 
	}
end



/* 
	SetCmd <cmdname>

	Preprocessor, calls <cmd>_sw to set command macros.
	See notes at eof
*/


program define SetCmd /* cmdname */
	global HSW_Pcmd
	global HSW_cons
	global HSW_op1 "Level(integer $S_level)"

					/* built-in abbreviations */
	if "`1'"=="reg" {
		local 1 "regress"
	}

					/* set	*/
	local cmd = substr("`1'",1,5)+"_sw"
	capture `cmd'
	if _rc { 
		local rc = _rc
		capture confirm var `1'
		if _rc == 0 { 
			di in red "syntax is  sw EST-COMMAND termlist ..."
			exit 198
		}
		if `rc'==199 {
			di in red "estimation command `1' not supported by sw"
			exit 199
		}
		di in red "error in `1' sw-interface `cmd':"
		error `rc'
end

program define regre_sw
	global HSW_cmd "regress"
	global HSW_typ "reg"
	global HSW_op0 "CLuster(string) HC2 HC3 Robust"
	global HSW_op1 "$HSW_op1 Beta"
end

program define fit_sw
	global HSW_cmd "regress"
	global HSW_Pcmd "fit"
	global HSW_typ "reg"
end

program define logit_sw
	global HSW_cmd "logit"
	global HSW_op0 "CLuster(string) Robust"
	global HSW_op1 "$HSW_op1 OR"
	global HSW_typ "ml"
	global HSW_res "BI"
	global HSW_cons "chkcons"
end

program define logis_sw
	global HSW_cmd "logit"
	global HSW_Pcmd "logistic"
	global HSW_op0 "CLuster(string) Robust"
	global HSW_typ "ml"
	global HSW_res "BI"
	global HSW_cons "chkcons"
end

program define probi_sw
	global HSW_cmd "probit"
	global HSW_op0 "CLuster(string) Robust"
	global HSW_typ "ml"
	global HSW_res "BI"
	global HSW_cons "chkcons"
end
		

program define DelTerm /* i */
	local i `1'
	local j `i'
	while `j' < $HSW_n {
		local k = `j'+1
		global HSW_`j' "${HSW_`k'}"
		local j = `j'+1
	}
	global HSW_`j'
	global HSW_n = $HSW_n - 1
end


program define DelVar /* varname */
	local vn "`1'"
	di in blu "(`vn' dropped due to estimability)"
	local i 1
	while `i' <= $HSW_n {
		parse "${HSW_`i'}", parse(" ")
		local j 1
		while "``j''" != "" {
			if "``j''"=="`vn'" {
				local `j' " "
				local n : word count `*'
				if _n==0 { 
					DelTerm `i'
					exit
				}
				parse "`*'", parse(" ")
				global HSW_`i' "`*'"
				exit
			}
			local j=`j'+1
		}
		local i=`i'+1
	}
	di in red "sw failure: could not find variable `vn'"
	exit 9498
end


program define chkcons
	capture local x = _se[_cons]
	if _rc {
		local x .
	}
	if `x'==0 | `x'==. {
		di in red "could not estimate _cons"
		exit 498
	}
end


/*
	CmdOpts <remaining options no comma>

		Converts predefined option masks $HSW_op0 and $HSW_op1
		to actual option lists.
*/


program define CmdOpts /* <remaining options> */
	local opts "`*'"
	local options "$HSW_op0 $HSW_op1 *"
	parse ", `*'"
	if "`options'" != "" {
		di in red "`options' not allowed"
		exit 198
	}
	
	local h0 "$HSW_op0"
	local h1 "$HSW_op1"
	local options "`h1' *"
	parse ", `*'"
	global HSW_op0 "`options'"

	local options "`h0' *"
	parse ", `*'"
	global HSW_op1 "`options'"
end


/* 
	AddT

	possibly add another term and leave it defined as current model.
	works for both ml and reg models.
	returns HSW_AddT==1 if term added, else HSW_AddT==0.
*/

program define AddT /* first */
	local first `1'
	if $HSW_k == $HSW_n { 
		global HSW_AddT 0
		exit
	}
	if "$HSW_typ" == "ml" {
		$HSW_res HSW_ll0 HSW_d0
	}
	estimates hold HSW_last
	local k = $HSW_k + 1
	local p1 2		/* find min sig */
	local kept 0
	while `k' <= cond($HSW_hier, $HSW_k+1, $HSW_n) {
		quietly $HSW_cmd $HSW_dv $HSW_base $HSW_cur ${HSW_`k'} $HSW_cmdX
		if "$HSW_typ" == "ml" {
			$HSW_res HSW_ll1 HSW_d1
			local p = chiprob($HSW_d1-$HSW_d0, /*
					*/ -2*($HSW_ll0-$HSW_ll1))
		}
		else {
			quietly test ${HSW_`k'}
			local p = cond(_result(5)==., /*
				*/ chiprob(_result(3),_result(6)), /*
				*/ fprob(_result(3),_result(5),_result(6)) )
		}
		if `p'< `p1' {
			local k1 `k'
			local p1 `p'
			if `p' < $HSW_Pe {
				local kept 1
				capture estimates drop HSW_last 
				capture estimates hold HSW_last
			}
		}
		local k = `k'+1
	}
	estimates unhold HSW_last
	if `kept' {
		global HSW_cur "$HSW_cur ${HSW_`k1'}"
		di in gr "p = " in ye %5.4f `p1' _c
		di in gr " <  " %5.4f $HSW_Pe "  adding   " in ye "${HSW_`k1'}"
		global HSW_k = $HSW_k + 1
		tswap $HSW_k `k1'
		global HSW_AddT 1
	}
	else {
		if $HSW_hier {
			di in gr "p = " in ye %5.4f `p1' in gr /*
				*/ " >= " %5.4f $HSW_Pe "  testing  " /*
				*/ in ye "${HSW_`k1'}"
		}
		else if `first' {
			di in gr "p >=" %5.4f $HSW_Pe _col(23) /*
			*/ "for all terms in model"
		}
		global HSW_AddT 0
	}
end

program define RmTreg
	local first `1'
	if $HSW_k == 0 { 
		global HSW_RmT 0
		exit
	}
	local k = cond($HSW_hier,$HSW_k,1)
	local k1 .
	local p1 -1
	while `k' <= $HSW_k {
		quietly test ${HSW_`k'}
		local p = cond(_result(5)==., /*
			*/ chiprob(_result(3),_result(6)), /*
			*/ fprob(_result(3),_result(5),_result(6)) )
		if `p' > `p1' {
			local k1 `k'
			local p1 `p'
		}
		local k = `k' + 1
	}
	if `p1' < $HSW_Pr {
		if $HSW_hier {
			di in gr "p = " in ye %5.4f `p1' _c
			di in gr " <  " %5.4f $HSW_Pr "  keeping  " in ye /*
				*/ "${HSW_`k1'}"
		}
		else if `first' {
			di in gr "p < " %5.4f $HSW_Pr _col(23) /*
			*/ "for all terms in model"
		}
		global HSW_RmT 0 
		exit 
	}
	di in gr "p = " in ye %5.4f `p1' _c
	di in gr " >= " %5.4f $HSW_Pr "  removing " in ye "${HSW_`k1'}"
	tswap `k1' $HSW_k
	global HSW_k = $HSW_k - 1
	MakeList $HSW_k
	quietly $HSW_cmd $HSW_dv $HSW_base $HSW_cur $HSW_cmdX
	global HSW_RmT 1
end

program define RmTml
	local first `1'
	if $HSW_k == 0 { 
		global HSW_RmT 0
		exit
	}
	$HSW_res HSW_ll1 HSW_d1
	local oldcur "$HSW_cur"
	estimates hold HSW_last

	local k = cond($HSW_hier, $HSW_k, 1)
	local k1 .
	local p1 -1
	local kept 0
	local truk $HSW_k
	local modk = $HSW_k - 1
	while `k' <= `truk' {
		tswap `k' `truk'
		MakeList `modk'
		quietly $HSW_cmd $HSW_dv $HSW_base $HSW_cur $HSW_cmdX
		$HSW_res HSW_ll0 HSW_d0
		local p = chiprob($HSW_d1-$HSW_d0, -2*($HSW_ll0-$HSW_ll1))
		if `p' > `p1' { 
			local p1 `p'
			local k1 `k'
			if `p' >= $HSW_Pr {
				capture estimates drop HSW_last
				estimates hold HSW_last
				local oldcur "$HSW_cur"
				local kept 1
			}
		}
		tswap `k' `truk'
		local k = `k'+1
	}
	global HSW_k `truk'
	if `kept' {
		di in gr "p = " in ye %5.4f `p1' _c
		di in gr " >= " %5.4f $HSW_Pr "  removing " in ye "${HSW_`k1'}"
		tswap `k1' $HSW_k 
		global HSW_k = $HSW_k - 1
		global HSW_RmT 1
	}
	else {
		if $HSW_hier {
			di in gr "p = " in ye %5.4f `p1' _c
			di in gr " <  " %5.4f $HSW_Pr "  keeping  " in ye /*
				*/ "${HSW_`k1'}"
		}
		else if `first' {
			di in gr "p < " %5.4f $HSW_Pr _col(23) /*
			*/ "for all terms in model"
		}
		global HSW_RmT 0 
	}
	estimates unhold HSW_last
	global HSW_cur "`oldcur'"
end

exit


Command macros set by <cmd>_sw:

	global macro	contents
	-----------------------------------------------------------------
	HSW_cmd		command to perform estimation

	HSW_Pcmd	post-estimation command (optional)

	HSW_typ 	"reg" | "ml"
			"reg" means always use -test- to test terms
			"ml"  means use -test- or likelihood-ratio test
	
	HSW_res		if "$HSW_typ"=="ml" only:  
			name of program to unload ll and dof.  May use
			"BI":  ll in _result(2) and dof in _result(3)
			"ADO": ll in $S_E_ll    and dof in $S_E_mdf
			any other program:  however you write it

	HSW_cons	"chkcons" | ""
			check that _se[_cons] defined, refuse if not.

	HSW_op0		option mask for estimation-time $HSW_cmd
			default: ""

	HSW_op1		option mask for reply $HSW_cmd
			default: "Level(integer $S_level)"
